#ifndef _BACKEND_H_
#define _BACKEND_H_

// trieda premennych a funkcii (objektov) pre pracu s OpenGL trojuholnikmi
class CBackend {
public:
 CBackend();  // konstruktor
 ~CBackend(); // destruktor

 // nacitanie vsetkych trojuholnikov
 int tris_add(void);
 // vykreslenie vsetkych trojuholnikov
 void tris_draw(void);
private:
 vec3 a0,a1,a2;    // pomocne vektory
 vec2 b0,b1,b2;
 GLfloat m0,m1,m2; // pomocne premenne

 GLuint segsNum; // pocet segmentov lightmapy v smere X

 GLuint act_lm;  // aktualna lightmapa
 GLuint act_seg; // aktualny segment lightmapy

 // doplnenie udajov nevyhnutnych pre pracu s trojuholnikmi
 void tris_upgrade(void);

 // reset indikatora spracovania pre vsetky trojuholniky
 void tris_done(void);

 // vytvorenie lightmap pre vsetky trojuholniky
 int tris_lightmaps(void);

 // vypocet odtiena lumelov patriacich konkretnemu segmentu lightmapy
 int set_lumels(GLint K,GLint L,GLuint N);

 // vypocet 3D suradnic lumelu
 void lumel_worldpos(vec3 *P,vec3 V0,vec3 V1,vec3 V2,
                     vec2 T0,vec2 T1,vec2 T2,
                     vec3 N,float D);
};

#endif
